/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Talk.h"
#include "GaduThread.h"
#include "Settings.h"
#include "Search.h"

#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TTalkForm *TalkForm;
extern TGaduThread *gg_thread;
extern AnsiString GGDir;
//---------------------------------------------------------------------------
__fastcall TTalkForm::TTalkForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TTalkForm::MyWndProc (Messages::TMessage &Msg)
{
        if (Msg.Msg == WM_NOTIFY)
        {
                if (((NMHDR*)Msg.LParam) -> code == EN_LINK)
                {
                        ENLINK *E = (ENLINK*)Msg.LParam;
                        if (E -> msg == WM_LBUTTONDBLCLK)
								//WinExec(Chat -> Text.SubString (E -> chrg.cpMin + 1, E -> chrg.cpMax - E -> chrg.cpMin).c_str(),SW_SHOWNORMAL);
								ShellExecute (NULL, NULL, Chat -> Text.SubString (E -> chrg.cpMin + 1, E -> chrg.cpMax - E -> chrg.cpMin).c_str(), NULL, NULL, SW_SHOW);
				}
		/** \todo ShellExecute zawsze uruchomi IE */		
//		String firefox  = "C:\\Program Files\\Mozilla Firefox\\firefox.exe ";
//		String dokum =
//		"file:///C:/Documents%20and%20Settings/Dino%20Pan/Pulpit/pierwszy.html";
//		 String ALL = firefox+dokum;
//
//		 WinExec(ALL.c_str() ,SW_MAXIMIZE);

        } else WndProc (Msg);
}
//---------------------------------------------------------------------------
void __fastcall TTalkForm::Edit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
        if (Key == VK_RETURN && !Shift.Contains(ssCtrl) && !Memo1 -> WantReturns && Memo1 -> Text != "") _SendMsg();
}
//---------------------------------------------------------------------------
void TTalkForm::_SendMsg()
{
		AnsiString send_msg = Memo1 -> Lines -> Text;

        gg_thread -> SendMsg (Tag, send_msg);

        Chat -> SelStart = Chat -> Lines -> Text.Length();

        Chat -> SelAttributes -> Size = 8;
        Chat -> SelAttributes -> Style = TFontStyles() << fsBold;
        Chat -> SelAttributes -> Color = clDkGray;
        Chat -> Paragraph -> FirstIndent = 0;
        Chat -> Lines -> Add (SettingsForm -> ListView1 -> Items -> Item[3] -> SubItems -> Strings[0] + ": (" + TimeToStr (Time())+ ") ");

        Chat -> SelAttributes -> Size = 10;
        Chat -> SelAttributes -> Style = TFontStyles();
        Chat -> SelAttributes -> Color = clBlue;
        Chat -> Paragraph -> FirstIndent = 10;
        Chat -> Lines -> Add (Memo1 -> Lines -> Text);

        SendMessage (Chat -> Handle, WM_VSCROLL, SB_BOTTOM, NULL);

        Memo1 -> Lines -> Clear();

        if (!DirectoryExists (log_file + "\\" + IntToStr(Tag))) CreateDir (log_file + "\\" + IntToStr (Tag));
        Chat -> Lines -> SaveToFile (log_file + "\\" + IntToStr(Tag) + "\\" + IntToStr(timestamp) + ".rtf");
}
//---------------------------------------------------------------------------
void __fastcall TTalkForm::FormCreate(TObject *Sender)
{
        SetWindowLong (Handle, GWL_EXSTYLE, GetWindowLong (Handle, GWL_EXSTYLE) | WS_EX_APPWINDOW);

        SendMessage (Chat -> Handle, EM_AUTOURLDETECT, TRUE, 0);
        SendMessage (Chat -> Handle, EM_SETEVENTMASK, 0, ENM_LINK);
        WindowProc = MyWndProc;

		timestamp = time(NULL);
		log_file += GGDir + "\\logs";
}
//---------------------------------------------------------------------------

void __fastcall TTalkForm::ToolButton2Click(TObject *Sender)
{
        Memo1 -> WantReturns = !ToolButton2 -> Down;
}
//---------------------------------------------------------------------------

void __fastcall TTalkForm::ToolButton1Click(TObject *Sender)
{
        if (Memo1 -> Lines -> Text != "") _SendMsg();
}
//---------------------------------------------------------------------------

void __fastcall TTalkForm::ToolButton4Click(TObject *Sender)
{
        for (int i = 0; i < SearchForm -> ComponentCount; i++)
                switch (SearchForm -> Components[i] -> Tag)
                {
                        case 101:
                                ((TEdit*) SearchForm -> Components[i]) -> Text = "";
                        break;

                        case 102:
                                ((TComboBox*) SearchForm -> Components[i]) -> ItemIndex = 0;
                        break;

                        case 103:
                                ((TCheckBox*) SearchForm -> Components[i]) -> Checked = false;
                        break;
                }

        SearchForm -> Show();
        SearchForm -> FMNumber -> Text = IntToStr(Tag);
        SearchForm -> fmstart -> Text = "0";
        SearchForm -> PageControl1 -> ActivePageIndex = 0;
        SearchForm -> Hide();

        SearchForm -> ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TTalkForm::FormShow(TObject *Sender)
{
        ShowWindow (Application -> Handle, SW_HIDE);
}
//---------------------------------------------------------------------------
void __fastcall TTalkForm::FormClose(TObject *Sender, TCloseAction &Action)
{
        WindowState = wsMinimized;
}
//---------------------------------------------------------------------------



